﻿using YamlDotNet.RepresentationModel;

class Config
{

    public static ConfigYaml config { get; set; }

    public Config()
    {
        loadConfig();
    }

    public static void loadConfig()
    {
        var deserializer = new YamlDotNet.Serialization.DeserializerBuilder().Build();

        string config_path = Environment.GetEnvironmentVariable("config_path");
        string html_output = Environment.GetEnvironmentVariable("html_output");
        string media_output = Environment.GetEnvironmentVariable("media_output");
        string mysql_string = Environment.GetEnvironmentVariable("mysql_string");

        var myConfig = deserializer.Deserialize<ConfigYaml>(File.ReadAllText(config_path));

        if (html_output != null)
        {
            myConfig.html_output = html_output;
        }

        if (media_output != null)
        {
            myConfig.media_output = media_output;
        }

        if (mysql_string != null)
        {
            myConfig.mysql_string = mysql_string;
        }

        config = myConfig;
    }

    public static ConfigYaml getConfig
    {
        get => config;
    }
}
