﻿using Newtonsoft.Json;
using System.Text;
using System.Text.RegularExpressions;

class GitlabCrawler : Crawler {

    public GitlabCrawler(ConfigYaml c, Source s) : base(c, s) { }

    public override void getLoadeableSources()
    {

        Dictionary<string, string> parameter = new Dictionary<string, string>() {
            {"simple", "true"},
            {"access_token", s.token},
            {"per_page", "100"}
        };

        string? return_value = APIInterface.Get($"{s.path}/api/v4/projects", parameter).Result;

        if (return_value != null) { 
            List<Project>? options_content = JsonConvert.DeserializeObject<List<Project>>(return_value);

            for (int i = 0; i < options_content.Count;i++) {

                int project_id = options_content[i].id;
                string project_name = options_content[i].name;

                Project p = options_content[i];

                Dictionary<string, string> gitlab_folder_parameter = new Dictionary<string, string>() {
                    {"path", s.public_folder},
                    {"access_token", s.token}
                };

                string? gitlab_folder = APIInterface.Get($"{s.path}/api/v4/projects/{project_id}/repository/tree", gitlab_folder_parameter).Result;
                List<GitlabFolder>? gitlab_folder_list = JsonConvert.DeserializeObject<List<GitlabFolder>>(gitlab_folder);

                if (gitlab_folder_list.Count > 0)
                {

                    var task = Task.Run(() => {
                        Gitlab f = new Gitlab(project_id, s, p);
                    });

                    task.ContinueWith(t => {
                        Console.WriteLine(t.Exception);
                    }, TaskContinuationOptions.OnlyOnFaulted);

                }
            }
        }
    }
}