﻿class APIInterface
{

    private static HttpClient Client = new HttpClient();

    public static async Task<byte[]> GetBinary(string uri, Dictionary<string, string> parameters)
    {
        HttpResponseMessage resp = await Client.GetAsync(CreateUri(uri, parameters));

        if (resp.StatusCode == System.Net.HttpStatusCode.NotFound)
            return null;

        if (resp.IsSuccessStatusCode)
        {
            return await resp.Content.ReadAsByteArrayAsync();
        }
        throw new HttpRequestException();
    }

    public static async Task<string> Get(string uri, Dictionary<string, string> parameters)
    {
        HttpResponseMessage resp = await Client.GetAsync(CreateUri(uri, parameters));

        if (resp.StatusCode == System.Net.HttpStatusCode.NotFound)
            return null;

        if (resp.IsSuccessStatusCode)
        {
            return await resp.Content.ReadAsStringAsync();
        }
        throw new HttpRequestException();
    }

    private static Uri CreateUri(string apiUrl, Dictionary<string, string>? par = null)
    {

        string full = apiUrl;

        if (par != null)
        {

            int lit = 0;
            foreach (KeyValuePair<string, string> val in par)
            {
                string splitter = lit == 0 ? "?" : "&";
                full = full + splitter + val.Key + "=" + val.Value;
                lit++;
            }

        }

        return new Uri(full);
    }
}