﻿using MySqlConnector;
using System.Data;

public class SQLDriver
{

    public int ExecuteWithoutResult(string sql)
    {
        using (var conn = new MySqlConnection(Config.getConfig.mysql_string))
        {
            using (var cmd = conn.CreateCommand())
            {
                conn.Open();
                cmd.CommandType = CommandType.Text;
                cmd.CommandText = sql;

                try
                {
                    return cmd.ExecuteNonQuery();
                }
                catch (MySqlException ex)
                {
                    Console.WriteLine(ex.StackTrace);
                    return -1;
                }
            }
        }
        return -1;
    }

    public DataTable ExecuteWithResult(string sql)
    {
        using (var conn = new MySqlConnection(Config.getConfig.mysql_string))
        {
            using (var cmd = conn.CreateCommand())
            {
                conn.Open();
                cmd.CommandType = CommandType.Text;
                cmd.CommandText = sql;

                try
                {
                    using (IDataReader reader = cmd.ExecuteReader())
                    {
                        DataTable dt = new DataTable();
                        dt.Load(reader);

                        return dt;
                    }
                }
                catch (MySqlException ex)
                {
                    Console.WriteLine(ex.StackTrace);
                    return null;
                }
            }
        }
        return null;
    }
}