﻿using Markdig;
using Markdig.Extensions.Bootstrap;
using System.Data;

class CrawlerSource
{
    public string project_path;
    public string? options_path;
    public OptionsJSON? options_content;
    public string? public_file_path;
    public string? public_file_content;
    public string? public_file_parsed_content;
    public string[] media_file_paths;
    public string? additional_markdown_content;
    public string? last_activity;

    public void saveToDB()
    {
        string path = project_path.Replace("\\", "\\\\");

        string query = $"select * from categories c where c.name = '{options_content.category}' ";

        SQLDriver mysql_connection = new SQLDriver();
        DataTable re = mysql_connection.ExecuteWithResult(query);

        int category_id;

        if (re.Rows.Count > 0)
        {
            DataRow sd = re.Rows[0];
            category_id = (int)sd.ItemArray[0];
            string sql = $"INSERT INTO projects (id, path, type, cloneable, name, preview_image, preview_text, category_id, alias, last_update, prod) VALUES (null, '{path}', '{options_content.type}', '{options_content.cloneable}', '{options_content.project_name}', '{options_content.preview_image}', '{options_content.preview_text}', {category_id}, '{options_content.project_alias_name}', '{this.last_activity}', {options_content.prod})";
            SQLDriver mysql_connection2 = new SQLDriver();
            mysql_connection2.ExecuteWithoutResult(sql);
        }
        else
        {
            Console.WriteLine($"Category of Project '{options_content.project_name}' not found.");
        }
    }

    protected string parsePublicFile()
    {

        string parsed_string = "";

        if (options_content.type == "markdown")
        {
            parsed_string = parseMardown(public_file_content);
        }
        else if (options_content.type == "html")
        {
            parsed_string = parseHtml(public_file_content);
        }

        if (additional_markdown_content != null)
        {
            parsed_string += parseMardown(additional_markdown_content);
        }

        return parsed_string;
    }

    public void savePublicFile()
    {
        using (StreamWriter writetext = new StreamWriter(Config.getConfig.html_output + Path.DirectorySeparatorChar + options_content.project_alias_name + ".html"))
        {
            writetext.Write(public_file_parsed_content);
        }
    }

    private string parseMardown(string md)
    {
        MarkdownPipeline pipeline = new MarkdownPipelineBuilder().UseAdvancedExtensions().Build();
        pipeline.Extensions.AddIfNotAlready<BootstrapExtension>();

        string media_path = getMediaPath();

        md = md.Replace("{media_path}", media_path);

        var result = Markdown.ToHtml(md, pipeline);

        return result;
    }

    public string getMediaPath()
    {
        string media_path = Config.getConfig.media_path;
        media_path = media_path.Replace("{project_alias_name}", this.options_content.project_alias_name);
        return media_path;
    }

    private string parseHtml(string html)
    {
        return html;
    }

    public void addAdditionalMardonContent(string content)
    {
        additional_markdown_content += content + "\n";
    }

}